#################################################################
#                                                               #
# discordに通知を送ります                                       #
#                                                               #
#                                             作成日：2024.07   #
#                               著作権「(C)UNION SYSTEM Inc.」  #
#                                                               #
#################################################################

# python3.10のターミナルから
# pip install discordwebhookを実行する
from discordwebhook import Discord

# Op.Python実行解説書サンプルプログラムの改変
# 計算書出力
from Python import Ss7Python as Cmd

# discordへのwebフック追加方法
# チャンネルの設定から連携サービスを開き
# ウェブフックを追加を行います。
# 通知を出したいチャンネルを指定し，
# [ウェブフックURLをコピー]を押してください。
# クリップボードに追加されたurlを下に貼ってください。（以下はurlサンプルです）
discord_hook = Discord(
    #url="https://discordapp.com/api/webhooks/1234567890123456789/xxxxxxxxxxxxx"
)
# discord.post(content="通知したい文章")を適宜ソースに組み込むことで，
# discordに通知を送ることができます。


Cmd.Init()
Cmd.Start("1.1.1.20", 1)  # 1=ログファイルをクリアする

# データを開く
DataPath = "C:\\UsrData\\Sample1.ikn"
Data = Cmd.Open(DataPath, 1, 3)  # 1=変換して開く 3=物件データは開かない
postMes = DataPath + "を開きます"
discord_hook.post(content=postMes)

ResultName = "結果3"
postMes = ResultName + "を開きます"
discord_hook.post(content=postMes)
# データが正しく開けたことの判定
if Data is not None:

    # 既に存在している場合は削除
    if Data.GetResultData(ResultName):
        discord_hook.post(content="既に結果が存在するため，削除します")
        Data.DeleteResult(ResultName)

    # 計算実行
    Data.Calculate(ResultName)

    # エラー情報を取得する
    err = Cmd.GetLastError()

    # 計算が正しく実行できたことの判定
    if err.IsOK() == True:

        discord_hook.post(content="計算が成功しました。構造計算書を出力します。")

        # 計算結果データを取得する
        res = Data.GetResultData(ResultName)

        Mess = err.GetErrorMessage()
        print(Mess)
        # 構造計算書を出力する
        res.CreateDocument(1, "構造計算書", 2)  # 1=構造計算書 2=中断する
        err = Cmd.GetLastError()

        # 構造計算書出力が正しく実行できたことの判定
        if err.IsOK() == True:
            discord_hook.post(content="構造計算書出力が成功しました")

        else:
            discord_hook.post(content="構造計算書出力が失敗しました")

        # データを閉じる
        Data.Close(1)  # 1=保存する
    else:
        discord_hook.post(content="計算が失敗しました")

        # データを閉じる
        Data.Close(2)  # 2=保存しない

Cmd.End(1)  # 1＝保存して終了
discord_hook.post(content="終了します")
